-- Color palette

log("  ╠ Color Manager")

color_palette = {
  white = {1, 1, 1},
  black = {0, 0, 0},
  --red = {1, 0, 0},
  --green = {0, 1, 0},
  --blue = {0, 0, 1},
  
  near_black = {.04, 0, .12},
  
  dark_blue = {0, 0, .64},
  
  red_panda = {1, .36, 0},
  
  
  ["true red"] = {1, 0, 0},
  ["true green"] = {0, 1, 0},
  ["true blue"] = {0, 0, 1},
  
  dark = {.1333, .1255, .2039},
  grey = {.5176, .4941, .5294},
  ["light grey"] = {.6078, .6784, .7176},
  ice = {.7961, .8588, .9882},
  steel = {.4118, .4157, 4157},
  ["dark grey"] = {.349, .3373, .3216},
  
  brown = {.4, .2235, .1922},
  ["light brown"] = {.5608, .3373, .2314},
  --orange = {.8745, .4431, .149},
  orange = {.96, .4431, .149},
  tan = {.851, .6275, .4},
  peach = {.9333, .7647, .6039},
  cork = {.5412, .4353, .1882},
  yellow = {.9843, .949, .2118},
  lime = {.6, .898, .3137},
  green = {.4157, .7451, .1882},
  turquoise = {.2157, .5804, .4314},
  ["dark green"] = {.2941, .4118, .1843},
  olive = {.3216, .2941, .1412},
  ["mute green"] = {.1961, .2353, .2235},
  ["light green"] = {.5608, .5922, .2902},
  purple = {.2471, .2471, .4549},
  ["steel blue"] = {.1882, .3765, .5098},
  lavender = {.3569, .4314, .8824},
  blue = {.3882, .6078, 1},
  teal = {.3725, .8039, .8941},
  plum = {.2706, .1569, .2353},
  ["dark purple"] = {.4627, .2588, .5412},
  --red = {.6745, .1961, .1961},
  red = {.96, .1961, .1961},
  ["light red"] = {.851, .3412, .3882},
  pink = {.8431, .4824, .7294},
}

function color(key, alpha)
  if type(key) == "table" then
    return key[1], key[2], key[3], (alpha or 1)
  else
    local swatch = color_palette[key]
    
    return swatch[1], swatch[2], swatch[3], (alpha or 1)
  end
end

function colorTable(key, alpha)
  local swatch = color_palette[key]
  
  return {swatch[1], swatch[2], swatch[3], (alpha or 1)}
end

function setColor(key, alpha)
  love.graphics.setColor(color(key, alpha))
end