log("  ╠ Obfuscation")

function obfuscate(data, copy)
  local ideal = string.len(data) + (3 - (string.len(data) % 4))
  
  while string.len(data) < ideal do
    data = data .. " "
  end
  
  local ret = ""
  
  for i = 4, string.len(data) * 4, 4 do
    local selection = i % ideal
    
    if selection == 0 then
      ret = ret .. string.sub(data, -1)
    else
      ret = ret .. string.sub(data, selection, selection)
    end
  end
  
  --print("\"" .. ret .. "\"")
  
  if copy then
    love.system.setClipboardText(ret)
  end
  
  return ret
end

function unobfuscate(data, trim, copy)
  local pattern = math.ceil(string.len(data) / 4)
  
  --print(pattern)
  
  local ret = ""
  
  for i = pattern, string.len(data) * pattern, pattern do
    local selection = i % (string.len(data) - ((i < string.len(data) and 1) or 0))
    
    if selection == 0 then
      ret = ret .. string.sub(data, -1)
    else
      ret = ret .. string.sub(data, selection, selection)
    end
  end
  
  if trim then
    local trim_length = 1
    
    while string.sub(ret, -trim_length, -trim_length) == " " do
      trim_length = trim_length + 1
    end
    
    ret = string.sub(ret, 1, -trim_length)
  end
  
  --print("\"" .. ret .. "\"")
  
  if copy then
    love.system.setClipboardText(ret)
  end
  
  return ret
end