-- Ratio and scale calculation

scale = { }

function scale.screenWidth(per)
  return love.graphics.getWidth() * per
end

function scale.screenHeight(per)
  return love.graphics.getHeight() * per
end

function scale.screen(per)
  return scale.screenWidth(per), scale.screenHeight(per)
end

function scale.gameWidth(per)
  return game_canvas:getWidth() * per
end

function scale.gameHeight(per)
  return game_canvas:getHeight() * per
end

function scale.game(per)
  return scale.gameWidth(per), scale.gameHeight(per)
end

ratio = { }

function ratio.screenWidth(comp)
  return love.graphics.getWidth() / comp
end

function ratio.screenHeight(comp)
  return love.graphics.getHeight() / comp
end

function ratio.screen(comp_w, comp_h)
  return ratio.screenWidth(comp_w), ratio.screenHeight(comp_h)
end

function ratio.screenRatio()
  
end

function ratio.gameWidth(comp)
  return (game_canvas:getWidth() / game_scale) / comp
end

function ratio.gameHeight(comp)
  return (game_canvas:getHeight() / game_scale) / comp
end

function ratio.game(comp_w, comp_h)
  return ratio.gameWidth(comp_w), ratio.gameHeight(comp_h)
end

function ratio.gameToScreen()
  return ratio.screen(game_canvas:getWidth(), game_canvas:getHeight())
end

-- Maths

function gcdiv(a, b)
  local ret = math.min(a, b)
  while ret > 0 do
    if a % ret == 0 and b % ret == 0 then
      break
    end
    ret = ret - 1
  end
  
  return ret
end

function lcm(a, b)
  return math.abs(a * b) / gcdiv(a, b)
end

function simplify(a, b)
  local div = gcdiv(a, b)
  
  return a / div, b / div
end