-- Timers

timers = { }
local deletion_queue = { }

function newTimer(fun, duration)
  local timer = {fun = fun, duration = duration, initial = duration}
  
  table.insert(timers, timer)
end

function clearTimers()
  timers = { }
end

function removeTimer(i)
  table.remove(timers, i)
end

function updateTimers(dt)
  for i, t in ipairs(timers) do
    t.duration = t.duration - dt
    
    if t.duration <= 0 then
      local success, vals = t.fun()
      
      if success then
        table.insert(deletion_queue, i)
      else
        if success == nil then
          print("ERROR: Timer " .. i .. " did not return a status!")
        end
        
        t.duration = t.duration + t.initial
      end
    end
  end
  
  while #deletion_queue > 0 do
    table.remove(timers, deletion_queue[#deletion_queue])
    table.remove(deletion_queue)
  end
end