-- GUI - Element

gui_element = { }
gui_element.__index = gui_element

setmetatable(gui_element, {
    __call = function(base, ...)
      local self = setmetatable({ }, base)
      self:new(...)
      return self
    end
  })

function gui_element:new(opt)
  if not opt then
    opt = { }
  end
  
  self.id = scene_manager:getCurrentScene().gui:newID()
  
  self.x = opt.x or 0
  self.y = opt.y or 0
  self.w = opt.w or 0
  self.h = opt.h or 0
  
  self.top = false
  
  self.onUpdate = opt.onUpdate
  self.onDraw = opt.onDraw
  
  return self
end

function gui_element:update(dt)
  if scene_manager:getCurrentScene().gui:getTopID() == self.id then
    self.top = true
  else
    self.top = false
  end
end

function gui_element:draw()
  
end

function gui_element:moveToTop()
  scene_manager:getCurrentScene().gui:moveToTop(self.id)
  
  return self
end

function gui_element:moveToBottom()
  scene_manager:getCurrentScene().gui:moveToBottom(self.id)
  
  return self
end

function gui_element:centerX()
  self.x = (game_canvas:getWidth() / 2) - (self.w / 2)
  
  return self
end

function gui_element:centerY()
  self.y = (game_canvas:getHeight() / 2) - (self.h / 2)
  
  return self
end

function gui_element:center()
  self:centerX()
  self:centerY()
  
  return self
end