-- Icon Handler

local icon_imgs = {
  love.graphics.newImage("gfx/system/icons_2x.png"),
  love.graphics.newImage("gfx/system/icons_raven_2x.png"),
}

local icon_quads = { }

icon_size = 32

function initIcons()
  log("Initializing icons...")
  total_icons = 0
  for _, img in ipairs(icon_imgs) do
    local quad_list = { }
    for y = 1, img:getHeight() / 32 do
      for x = 1, img:getWidth() / 32 do
        table.insert(quad_list, love.graphics.newQuad((x - 1) * 32, (y - 1) * 32, 32, 32, img:getWidth(), img:getHeight()))
        total_icons = total_icons + 1
      end
    end
    table.insert(icon_quads, quad_list)
  end
  log("Icons initialized! Loaded " .. total_icons .. "!")
end

function drawIcon(index, x, y, ...)
  local _, _, _, a = love.graphics.getColor()
  setColor("white", a)
  --love.graphics.rectangle("fill", x, y, 32, 32)
  if index <= 0 then
    return
  elseif index <= 1136 then
    --[[local old_odist = getOutlineDist()
    setOutlineDist(1)
    love.graphics.drawqo(icon_imgs[1], icon_quads[1][index], x, y, ...)
    setOutlineDist(old_odist)]]
    love.graphics.draw(icon_imgs[1], icon_quads[1][index], x, y, ...)
  elseif index <= 9552 then
    index = index - 1136
    love.graphics.draw(icon_imgs[2], icon_quads[2][index], x, y, ...)
  end
end

function drawIconCentered(index, x, y, r, sx, sy, ox, oy, ...)
  drawIcon(index, x, y, r, sx, sy, (ox or 0) + 16, (oy or ox or 0) + 16, ...)
end