-- Icon List

local scene = { }

function scene:load(opt)
  self.gui = gui()
  
  local ran = random(2, total_icons)
  
  self.title_window = self.gui:newMessage({
      text = {
        text = {"/icon 24", "Icon Directory"},
        instant = true
      },
      static = true,
      no_auto_size = true,
      w = canvasWidth(.2),
      h = 54
    }):open()
  
  local icon_options = { }
  local first = true
  local next_x = 0
  local next_y = 4
  for i = 1, total_icons do
    local new_text = text({
        text = {"/icon " .. i},
        x = next_x,
        y = next_y
      })
    
    table.insert(icon_options, new_text)
    
    next_x = (next_x + 56) % (18 * 56)
    if first then
      first = false
    elseif next_x == 0 then
      next_y = next_y + 56
    end
  end
  
  self.icon_menu = self.gui:newMenu({
      y = self.title_window.th,
      w = canvasWidth(.8),
      h = canvasHeight() - self.title_window.th,
      freeform = true,
      freeform_lr = true,
      lr_jump = 18 * 12,
      options = icon_options,
      greyed_out = function(self, option)
        if not self.highlight_mode then
          return false
        else
          return self:getCurrentOption() ~= option
        end
      end,
      onX = function(self)
        self.highlight_mode = not self.highlight_mode
      end
    }):open()
end

function scene:update(dt)
  self.gui:update(dt)
end

function scene:draw()
  love.graphics.printo("1x        " .. self.icon_menu.option .. "\n\n\n2x\n\n\n\n3x", canvasWidth(.8) + 32, 64)
  drawIcon(self.icon_menu.option, canvasWidth(.8) + 32, 96)
  drawIcon(self.icon_menu.option, canvasWidth(.8) + 32, 184, 0, 2)
  drawIcon(self.icon_menu.option, canvasWidth(.8) + 32, 296, 0, 3)
  
  self.gui:draw()
end

return scene